﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Globalization;

namespace prj_ApplySearchInvisbleColumns
{
    public partial class Form1 : Form
    {
        DataTable dt = new DataTable();
        bool flag = false;
        string searchString = null;
        public Form1()
        {
            InitializeComponent();
            dt.Columns.Add("CustomerID", typeof(int));
            dt.Columns.Add("ContactName", typeof(string));
            dt.Columns.Add("Designation", typeof(string));
            dt.Columns.Add("Country", typeof(string));

            //Sample Data
            dt.Rows.Add(1, "Maria Anders", "Sales Representative", "Spain");
            dt.Rows.Add(2, "Ana Trujillo", "Sales Associate", "Mexico");
            dt.Rows.Add(3, "Antonio Moreno", "Owner", "Ireland");
            dt.Rows.Add(4, "Thomas Hardy", "Sales Representative", "UK");
            dt.Rows.Add(5, "Patricio Simpson", "Marketing Manager", "Germany");
            dt.Rows.Add(6, "Paolo Accorti", "Sales Representative", "Spain");
            dt.Rows.Add(7, "Martine Rancé", "Owner", "Mexico");
            dt.Rows.Add(8, "Elizabeth Brown", "Marketing Manager", "UK");
            dt.Rows.Add(9, "Jaime Yorres", "Order Administrator", "Austria");
            dt.Rows.Add(10, "Yvonne Moncada", "Marketing Manager", "Mexico");
            dt.Rows.Add(11, "Helen Bennett", "Owner/Marketing", "Ireland");
            dt.Rows.Add(12, "Sergio Gutiérrezy", "Order Administrator", "Brazil");
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.DataSource = dt;
        }
        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text != null)
            {
                searchString = textBox1.Text;
            }
            c1FlexGrid1.ApplySearch(searchString,true,true);
            for (int r = 1; r < c1FlexGrid1.Rows.Count; r++)
            {
                flag = false;
                if (c1FlexGrid1.Rows[r].Visible)
                {
                    for (int c = 1; c < c1FlexGrid1.Cols.Count; c++)
                    {
                        if (!c1FlexGrid1.Cols[c].Visible)
                        {
                            int index = c1FlexGrid1.GetData(r, c).ToString().IndexOf(searchString, StringComparison.CurrentCultureIgnoreCase);
                            if(index!=-1)
                            {
                                flag = true;
                                break;
                            }
                        }
                    }
                    if (flag)
                    {
                        c1FlexGrid1.Rows[r].Visible = false;
                    }
                }
            }
        }
        private void button2_Click(object sender, EventArgs e)
        {
            c1FlexGrid1.Cols["ContactName"].Visible = false;
        }     
    }
}
